/*
 * generated by Xtext 2.26.0
 */
package org.eclipse.gef.dot.internal.language.serializer;

import com.google.inject.Inject;
import java.util.Set;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.gef.dot.internal.language.recordlabel.Field;
import org.eclipse.gef.dot.internal.language.recordlabel.FieldID;
import org.eclipse.gef.dot.internal.language.recordlabel.RLabel;
import org.eclipse.gef.dot.internal.language.recordlabel.RecordlabelPackage;
import org.eclipse.gef.dot.internal.language.services.DotRecordLabelGrammarAccess;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;

@SuppressWarnings("all")
public class DotRecordLabelSemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private DotRecordLabelGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == RecordlabelPackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case RecordlabelPackage.FIELD:
				sequence_Field(context, (Field) semanticObject); 
				return; 
			case RecordlabelPackage.FIELD_ID:
				sequence_FieldID(context, (FieldID) semanticObject); 
				return; 
			case RecordlabelPackage.RLABEL:
				sequence_RLabel(context, (RLabel) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * <pre>
	 * Contexts:
	 *     FieldID returns FieldID
	 *
	 * Constraint:
	 *     ((portNamed?='&lt;' port=String?)? name=String?)
	 * </pre>
	 */
	protected void sequence_FieldID(ISerializationContext context, FieldID semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Field returns Field
	 *
	 * Constraint:
	 *     (fieldID=FieldID | label=RLabel)
	 * </pre>
	 */
	protected void sequence_Field(ISerializationContext context, Field semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     RLabel returns RLabel
	 *
	 * Constraint:
	 *     (fields+=Field fields+=Field*)
	 * </pre>
	 */
	protected void sequence_RLabel(ISerializationContext context, RLabel semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
}
